/*
 * Author: Jake G
 * Date: 2024-09-01
 * filename: SuperLoop.c
 * description: The RT super loop.
 */

#include "SuperLoop.h"
#include <stdbool.h>

static uint8_t iteration_target = 0;

/*
 * ####################################
 * PRIVATE FUNCTIONS
 * ####################################
 */

static bool continue_looping(uint8_t idx) {
  if (iteration_target == 0 || idx <= iteration_target) {
    return true;
  }
  return false;
}

/*
 * ####################################
 * PUBLIC FUNCTIONS
 * ####################################
 */

void SuperLoop_SetIterations(uint8_t n) { iteration_target = n; }

uint8_t SuperLoop_Run(void) {
  uint8_t i;
  for (i = 0; continue_looping(i); i++) {
    continue;
  }
  return i - 1;
}
